<?php

define('CASE_ID', 1);
define('TEAM_ID', 818);
//define('PC_AVATAR_NAME', 'Gerhard Tomorrow'); // note: pc uid defined in vcp_case table
//define('PC_AVATAR_NAME', 'Memoree Lane'); // note: pc uid defined in vcp_case table
define('PC_AVATAR_NAME', 'ac Eberhardt'); // note: pc uid defined in vcp_case table

define('SL_PRESENTATION_DIR_ROOT','VCP');
define('FULLNAME_FIELD_ID', 1);

function vcp_help($path, $arg){
	$output = '';
	switch ($path) {
		case "admin/help#vcp":
			$output = '<p>'.t("Supports users using the VCP").'</p>';
			break;
	}
	return $output;
}

function vcp_perm() {
  	return array('access VCP support');
}

/**
* Implementation of hook_block
* @param string $op one of "list", "view", "save" and "configure"
* @param integer $delta code to identify the block
* @param array $edit only for "save" operation
**/
function vcp_block($op = 'list', $delta = 0, $edit = array()) {
	global $user;
	
	if ($op == 'list') {
    		// Generate listing of blocks from this module, for the admin/block page
    		$block = array();
    		$block[0]["info"] = t('VCP support');
    		return $block;
  	} else if ($op == 'view') {
		// Generate content: set up the block depending on requested page:
		$request_uri = $_SERVER["REQUEST_URI"];
		$team = get_team_members(TEAM_ID);
		if (($request_uri == '/progress-overview') || ($request_uri == '/teamA')) {
			$block['subject'] = 'VCP Progress: Overview';
			$block['content'] = progress_form();
			return $block;
		}
		if ($request_uri == '/individual-problem-map') {
			$block['subject'] = 'VCP Individual Problem Map for ' . get_fullname($team, $user->uid);
			$block['content'] = individual_pm_form();
			return $block;
		}
		if ($request_uri == '/integrated-problem-map') {
			$block['subject'] = 'VCP Integrated Problem Map';
			$block['content'] = integrated_pm_form();
			return $block;
		}
		if(($request_uri == '/og/users/'. TEAM_ID) || ($request_uri == '/og/users/'. TEAM_ID .'/faces')) {
			$block['subject'] = 'VCP Team Member Roles';
			$block['content'] = case_form($team);
			return $block;
		}
		if ($request_uri == '/individual-experience-matrix') {
			$block['subject'] = 'VCP Individual Experience Matrix for ' . get_fullname($team, $user->uid);
			$block['content'] = individual_em_form();
			return $block;
		}
		if ($request_uri == '/accountability-matrix') {
			$block['subject'] = 'VCP Integrated Team Experience and Accountability Matrix';
			$block['content'] = accountability_form($team);
			return $block;
		}
		// default:
		$block['subject'] = 'VCP Support';
		$block['content'] = '<b>Page not supported.</b>';
		return $block;
	}
}


function progress_form() {
	global $user;
	
	$case_id = CASE_ID;
	$case_info = get_case_info($case_id);
	$form = '<h2>Case: ' . $case_info->name . '</h2>';
	$form .= '<p>[<a href="/wiki/Procedure:Update_VCP_Progress_Overview" target="_blank">Help: SOP</a>]</p>';
	
	$form .= '<p><form action="' . $_SERVER["REQUEST_URI"] . '" method="post">';
	
	if (isset($_REQUEST['done_request'])) {
		// update the current phase:
		if (isset($_REQUEST['phase']) && in_array($case_info->phase, $_REQUEST['phase'])) {
		$phaseinfo = db_fetch_object(
			db_query('SELECT * FROM vcp_phase WHERE phase=' . $case_info->phase));
		$case_info->phase = $phaseinfo->next;
			db_query('UPDATE vcp_case SET phase=%d WHERE cid=%d',$case_info->phase,$case_id);
		}
	}
	
	$form .= '<p><table border="1" cellpadding="4" width="100%">';
	$form .= '<tr><th>VCP Task</th><th width="10%">Help</th><th width="10%">Completed</th></tr>';
	
	$form .= '<tr><td colspan="3" bgcolor="#eeeeee"><b><a href="/wiki/Procedure:Introduce_Process_Coordinator_to_Team_and_Communicate_Case_for_Team_Members_to_Establish_Core_Problem_Dimensions_(Pre-Meeting)" target="_blank">Before Meeting 1</a></b>:</td></tr>';
	$form .= get_phase_row(11, $case_info->phase);
	$form .= get_phase_row(12, $case_info->phase);
	$form .= get_phase_row(13, $case_info->phase);
	
	$form .= '<tr><td colspan="3" bgcolor="#eeeeee"><b><a href="/wiki/Procedure:Introductions,_Agree_on_Team_Process_Guidelines_and_Define/Rate_Core_Problem_Dimensions_(First_Second_Life_Meeting)" target="_blank">Meeting 1</a></b>:</td></tr>';
	$form .= get_phase_row(21, $case_info->phase);
	$form .= get_phase_row(22, $case_info->phase);
	
	$form .= '<tr><td colspan="3" bgcolor="#eeeeee"><b><a href="/wiki/Procedure:Develop_Awareness_and_Bases_of_Expertise_within_the_Team_for_each_Core_Problem_Dimension_(Pre-Meeting)" target="_blank">Before Meeting 2</a></b>:</td></tr>';
	$form .= get_phase_row(31, $case_info->phase);
	$form .= get_phase_row(32, $case_info->phase);
	
	$form .= '<tr><td colspan="3" bgcolor="#eeeeee"><b><a href="/wiki/Procedure:Agree_on_Task_Roles,_Discussion_Norms_and_Solution_Development_Process_for_each_Core_Problem_Dimension_(Second_Second_Life_Meeting)" target="_blank">Meeting 2</a></b>:</td></tr>';
	$form .= get_phase_row(41, $case_info->phase);
	$form .= get_phase_row(42, $case_info->phase);
	$form .= get_phase_row(43, $case_info->phase);
	
	$form .= '<tr><td colspan="3" bgcolor="#eeeeee"><b><a href="/wiki/Procedure:Produce_Initial_Individual_Solution_Templates,_Provide_Comments_On_All_Individual_Solution_Templates_and_Update_Individual_Solution_Templates_with_Feedback_(Pre-Meeting)" target="_blank">Before Meeting 3</a></b>:</td></tr>';
	$form .= get_phase_row(51, $case_info->phase);
	$form .= get_phase_row(52, $case_info->phase);
	
	$form .= '<tr><td colspan="3" bgcolor="#eeeeee"><b><a href="/wiki/Procedure:Present_Interim_Solutions,_Identify_Gaps_and_Begin_Compiling_Full_Plan_Document_(Third_Second_Life_Meeting)" target="_blank">Meeting 3</a></b>:</td></tr>';
	$form .= get_phase_row(61, $case_info->phase);
	
	$form .= '<tr><td colspan="3" bgcolor="#eeeeee"><b><a href="/wiki/Procedure:Post_Initial_Integrated_Plan_Document_and_Complete" target="_blank">After Meeting 3</a></b>:</td></tr>';
	$form .= get_phase_row(71, $case_info->phase);
	
	$form .= '</table></p>';
	if (($user->uid == $case_info->coordinator) || ($user->uid == 1)) {
		$form .= '<p align="center"><input type="submit" name="done_request" value="Save" /></p>';
	} else {
		$form .= '<p align="center"><b>Progress can only be updated by the process coordinator.</b></p>';
	}
	$form .= '</form>';
	return $form;
}

function get_phase_row($phase, $current) {
	$phaseinfo = db_fetch_object(
		db_query('SELECT * FROM vcp_phase WHERE phase=' . $phase));
	$help = ($phaseinfo->sop == null) ? 
		'-' : '<a href="' . $phaseinfo->sop . '" target="_blank">SOP</a>';
	$trow = ($current == $phase) ? '<tr bgcolor="#e0edc5">' : '<tr>';
	return $trow . '<td>' . $phaseinfo->text . ' </td><td>' . $help . '</td><td>' . 
		checkbox('phase[]', $phase, ($current > $phase), 'done', ($current == $phase)) . 
		'</td></tr>';
}


function individual_pm_form() {
	global $user;
	
	$priorities = array('high','medium','low');
	
	$case_id = CASE_ID;
	$case_info = get_case_info($case_id);
	$form = '<h2>Case: ' . $case_info->name . '</h2>';
	$form .= '<p>[<a href="/wiki/Procedure:Complete_Individual_Problem_Map" target="_blank">Help: SOP</a>]</p>';
	
	if ($case_info->phase < 12) {
		return $form . '<p style="font-weight:bold; color:red">Not yet enabled. Please contact the process coordinator.</p>';
	}
	
	$editable = ($case_info->phase <= 12);
	if ($editable && isset($_REQUEST['nr_dimensions'])) {
		$nr_dims = $_REQUEST['nr_dimensions'];
		$dimensions = get_dimensions($case_id, $user->uid);
		for ($i = 0; $i < $nr_dims; $i++) {
		
			// insert new versions for changed rows:
			$dim_i = $dimensions[$i];
			$new_dim = trim($_REQUEST['dimension_' . $i]);
			$new_ratio = trim($_REQUEST['rationale_' . $i]);
			$new_p = $_REQUEST['priority_' . $i];
			if (($dim_i->description != $new_dim) || 
					($dim_i->rationale != $new_ratio) || 
					($dim_i->priority != $new_p)) {
				db_query(
					'INSERT INTO vcp_dimension ' .
						'(did, cid, vid, uid, description, rationale, priority) ' .
					'VALUES ' . 
						'(%d,%d,%d,%d,"%s","%s","%s")', 
						$dim_i->did, $case_id, ($dim_i->vid)+1, $user->uid, $new_dim, $new_ratio, $new_p);
			}
		}
		
		// insert new dimension if last row is not empty:
		$new_dim = trim($_REQUEST['dimension_new']);
		$new_ratio = trim($_REQUEST['rationale_new']);
		$new_p = $_REQUEST['priority_new'];
		if ((strlen($new_dim) != 0) || (strlen($new_ratio) != 0)) {
			db_query(
				'INSERT INTO vcp_dimension ' .
					'(cid, vid, uid, description, rationale, priority) ' .
				'VALUES '.
					'(%d,%d,%d,"%s","%s","%s")', 
					$case_id, 1, $user->uid, $new_dim, $new_ratio, $new_p);
		}
	}
	
	// generate the form from the database content:
	$dimensions = get_dimensions($case_id, $user->uid);
	$nr_dims = sizeof($dimensions);
	$form .= '<p><form action="' . $_SERVER["REQUEST_URI"] . '" method="post">';
	$form .= '<input type="hidden" name="nr_dimensions" value="' . $nr_dims . '" />';
	$form .= '<p><table border="1" cellpadding="4" width="100%">';
	$form .= '<tr><th>Dimension</th><th>Rationale</th><th>Ranking</th></tr>';
	
	$ta_style = $editable ? 'width:98%' : 'width:98%; background: #eeeeee';
	for ($i = 0; $i < $nr_dims; $i++) {
		// write row for existing dimensions:
		$form .= '<tr>';
		$dim_i = $dimensions[$i];
		$form .= '<td>' . textarea($dim_i->description, 'dimension_'.$i, 8, $ta_style, $editable) . '</td>';
		$form .= '<td>' . textarea($dim_i->rationale, 'rationale_'.$i, 8, $ta_style, $editable) . '</td>';
		$form .= '<td>';
		foreach ($priorities as $n => $value) {
			$checked = ($dim_i->priority == $value);
			$form .= radio_button('priority_'.$i, $value, $checked, $value, $editable) . '<br />';
		}
		$form .= '</td></tr>';
	}
	
	if ($editable) {
		// write row for new dimension:
		$form .= '<tr>';
		$form .= '<td>' . textarea('', 'dimension_new', 8, 'width:98%') . '</td>';
		$form .= '<td>' . textarea('', 'rationale_new', 8, 'width:98%') . '</td>';
		$form .= '<td>';
		foreach ($priorities as $n => $value) {
			$checked = ($value == 'medium');
			$form .= radio_button('priority_new', $value, $checked, $value) . '<br />';
		}
		$form .= '</td></tr>';
	}
	
	$form .= '</table></p>';
	if ($editable) {
		$form .= '<p align="center">' . submit_button('Save changes / Add dimension', null) . '</p>';
	} else {
		$form .= '<p align="center"  style="font-weight:bold; color:red">The individual problem map can no longer be updated.</p>';
	}
	$form .= '</form>';
	return $form;
}


function integrated_pm_form() {
	global $user;
	
	$priorities = array('high','medium','low');
	
	$case_id = CASE_ID;
	$case_info = get_case_info($case_id);
	$form = '<h2>Case: ' . $case_info->name . '</h2>';
	$form .= '<p>[<a href="wiki/Procedure:Create_Integrated_Problem_Map" target="_blank">Help: SOP</a>]</p>';
	
	if ($case_info->phase < 13) {
		return $form . '<p style="font-weight:bold; color:red">Not yet enabled. See the <a href="progress-overview">progress overview</a> page.</p>';
	}
	
	// altered this - integrated map now available up to phase 31:
	$editable = (($case_info->phase < 31) && 
		(($user->uid == $case_info->coordinator) || ($user->uid == 1)));
	if ($editable && isset($_REQUEST['nr_dimensions'])) {
		$nr_dims = $_REQUEST['nr_dimensions'];
		$dimensions = get_dimensions($case_id, -1);
		$do_merge = array();
		for ($i = 0; $i < $nr_dims; $i++) {
		
			// insert new versions for changed rows:
			$dim_i = $dimensions[$i];
			$new_dim = trim($_REQUEST['dimension_' . $i]);
			$new_ratio = trim($_REQUEST['rationale_' . $i]);
			$new_p = $_REQUEST['priority_' . $i];
			if (($dim_i->description != $new_dim) || 
					($dim_i->rationale != $new_ratio) || 
					($dim_i->priority != $new_p)) {
				db_query(
					'INSERT INTO vcp_dimension ' .
						'(did, cid, vid, uid, description, rationale, priority) ' .
					'VALUES ' . 
						'(%d,%d,%d,-1,"%s","%s","%s")', 
						$dim_i->did, $case_id, ($dim_i->vid)+1, $new_dim, $new_ratio, $new_p);
			}
			
			// delete from the integrated version as required:
			$action = $_REQUEST['action_' . $i];
			if ($action == 'delete') {
				db_query(
					'UPDATE vcp_dimension SET integrated=0 WHERE did=%d', $dim_i->did);
			} else if ($action == 'merge') {
				$do_merge[] = $i;
			}
		}
		
		// merge dimensions if required:
		if (sizeof($do_merge) >= 2) {
			$mdim0 = $do_merge[0];
			$new_dim = trim($_REQUEST['dimension_'.$mdim0]);
			$new_rat = trim($_REQUEST['rationale_'.$mdim0]);
			$new_pri = $_REQUEST['priority_'.$mdim0];
			foreach ($do_merge as $n => $mdim){
				if($n > 0){
					$new_dim .= ' AND '.trim($_REQUEST['dimension_'.$mdim]);
					$new_rat .= ' AND '.trim($_REQUEST['rationale_'.$mdim]);
					$thispri = $_REQUEST['priority_'.$mdim];
					if(array_search($thispri, $priorities) < array_search($new_pri, $priorities))
						$new_pri = $thispri;
				}
				// next 'delete' old dimension:
				$dim_i = $dimensions[$mdim];
				db_query('UPDATE vcp_dimension SET integrated=0 WHERE did=%d', $dim_i->did);
			}
			// ...and finally add a new dimension:
			db_query(
				'INSERT INTO vcp_dimension ' .
					'(cid, vid, uid, description, rationale, priority) ' .
				'VALUES '.
					'(%d,1,-1,"%s","%s","%s")', $case_id, $new_dim, $new_rat, $new_pri);
		}
	}
	
	if ($editable && isset($_REQUEST['generate_request']) && ($nr_dims > 0)) {
		global $base_url;

		// create an empty directory for the presentation:
		$avatarname = preg_replace('/\s+/','_',trim(PC_AVATAR_NAME));
		$adir = realpath('.').file_directory_temp().'/'.$avatarname; // avatar dir - may already exist
		if (!is_dir($adir))
			mkdir($adir);
		$pname = SL_PRESENTATION_DIR_ROOT.'-Dimensions';
		$pdir = $adir.'/'.$pname.'/'; // presentation dir
		unlinkRecursive($pdir, true);
		mkdir($pdir);

		// generate a new 'slide' for each dimension:
		for ($i = 0; $i < $nr_dims; $i++) {
			$fp = fopen($pdir.'slide'.$i.'.html', 'w');
			fwrite($fp, '<html><head><meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>');
			fwrite($fp, '<style type="text/css">'
					.'h1,h2,p { font-family: "Arial Black"; margin: 40px }'
					.'h1 {font-size: 36pt; text-align: center}'
					.'h2 {font-size: 24pt}'
					.'p {font-size: 18pt}</style></head><body>');
			//fwrite($fp, '<h1>'.$case_info->name.': Problem Dimension #'.($i+1).'</h1>');
			fwrite($fp, '<h1>Problem Dimension #'.($i+1).'</h1>');
			
			$dim_i = $dimensions[$i];
			fwrite($fp, '<h2>Dimension</h2><p>'.$dim_i->description.'</p>');
			fwrite($fp, '<h2>Rationale</h2><p>'.$dim_i->rationale.'</p>');
			fwrite($fp, '<h2>Ranking</h2><p>'.$dim_i->priority.'</p></body></html>'); 

			fclose($fp);
		}

		// write the URLs to the slides:
		$form .= '<p>Presentation '.$pname.' has been generated:</p><ul>';
		$urlroot = $base_url.file_directory_temp().'/'.$avatarname.'/'.$pname.'/slide';
		for ($i = 0; $i < $nr_dims; $i++) {
			$fullurl = $urlroot.$i.'.html';
			$form .= '<li><a href="'.$fullurl.'">'.$fullurl.'</a></li>';
		}
		$form .= '</ul>';
	}
	
	// generate the form from the database content:
	$dimensions = get_dimensions($case_id, -1);
	$nr_dims = sizeof($dimensions);
	$form .= '<p><form action="' . $_SERVER["REQUEST_URI"] . '" method="post">';
	$form .= '<input type="hidden" name="nr_dimensions" value="' . $nr_dims . '" />';
	$form .= '<p><table border="1" cellpadding="4" width="100%">';
	$form .= '<tr><th>#</th><th>Dimension</th><th>Rationale</th><th>Ranking</th><th>Action</th></tr>';

	$ta_style = $editable ? 'width:98%' : 'width:98%; background: #eeeeee';
	for ($i = 0; $i < $nr_dims; $i++) {

		// write row for existing dimensions:
		$form .= '<tr>';
		$form .= '<td><b>' . ($i+1) . '</b></td>';
		$dim_i = $dimensions[$i];
		$form .= '<td>' . textarea($dim_i->description, 'dimension_'.$i, 8, $ta_style, $editable) . '</td>';
		$form .= '<td>' . textarea($dim_i->rationale, 'rationale_'.$i, 8, $ta_style, $editable) . '</td>';
		$form .= '<td>';
		foreach ($priorities as $n => $value) {
			$checked = ($dim_i->priority == $value);
			$form .= radio_button('priority_'.$i, $value, $checked, $value, $editable) . '<br />';
		}
		$form .= '</td><td>';
		$form .= radio_button('action_'.$i, 'merge', false, 'merge', $editable) . '<br />';
		$form .= radio_button('action_'.$i, 'delete', false, 'delete', $editable) . '<br />';
		$form .= radio_button('action_'.$i, 'none', true, 'keep', $editable) . '<br />';
		$form .= '</td></tr>';
	}
	
	$form .= '</table></p>';
	if ($editable) {
		$form .= '<p align="center">' . submit_button('Update Integrated Map', 'update_request') . ' ';
		$form .= submit_button('Update and Generate Presentation', 'generate_request') . '</p>';
	} else {
		if (($user->uid == $case_info->coordinator) || ($user->uid == 1))
			$form .= '<p align="center"  style="font-weight:bold; color:red">The integrated problem map can no longer be updated.</p>';
		else
			$form .= '<p align="center"  style="font-weight:bold; color:red">The integrated problem map can only be updated by the process coordinator.</p>';
	}
	$form .= '</form>';

	return $form;
}


function case_form($team) {
	global $user;
	
	$case_id = CASE_ID;
	$case_info = get_case_info($case_id);
	$form = '<h2>Case: ' . $case_info->name . '</h2>';
	$form .= '<p>[<a href="/wiki/Procedure:Agree_Project_Roles" target="_blank">Help: SOP</a>]</p>';

// SEP make roles visible at all times:
//	if ($case_info->phase < 13) {
//		return $form . '<p style="font-weight:bold; color:red">Not yet enabled. See the <a href="progress-overview">progress overview</a> page.</p>';
//	}

// SEP make roles editable from phase 13 onwards:
//	$editable = (($case_info->phase >= 13) && ($case_info->phase <= 43) &&
	$editable = (($case_info->phase >= 13) && 
		(($user->uid == $case_info->coordinator) || ($user->uid == 1)));
	if ($editable && isset($_REQUEST['save_request'])) {
		if ($case_info->taskman != $_REQUEST['taskman']) {
			db_query('UPDATE vcp_case SET taskman='.$_REQUEST['taskman'].' WHERE cid='.CASE_ID);
		}
		if ($case_info->gatekeeper != $_REQUEST['gatekeeper']) {
			db_query('UPDATE vcp_case SET gatekeeper='.$_REQUEST['gatekeeper'].' WHERE cid='.CASE_ID);
		}
		if ($case_info->integrator != $_REQUEST['integrator']) {
			db_query('UPDATE vcp_case SET integrator='.$_REQUEST['integrator'].' WHERE cid='.CASE_ID);
		}
		// reload case info:
		$case_info = get_case_info($case_id);
	}
	
	$form .= '<p><form action="' . $_SERVER["REQUEST_URI"] . '" method="post">';
	$form .= '<p><table border="1" cellpadding="4" width="100%">';
	$form .= '<tr><th>Role</th><th>Expectations</th><th>Team Member</th></tr>';
	
	$form .= '<tr><td>Process coordinator</td><td>To help frame the problem dimensions and establish team processes for solution development.</td><td>' . 
			get_fullname($team, $case_info->coordinator) . '</td></tr>';
			
	$uid = $case_info->taskman;
	$member_entry = (($user->uid == $case_info->coordinator) || ($user->uid == 1)) ?
			get_team_menu($team, 'taskman', 'not assigned', $uid, $editable) :
			(($uid > 0) ? get_fullname($team, $uid) : 'not assigned');
	$form .= '<tr><td>Case planner</td><td>Document and remind people of deliverables. Help us to all keep on plan for delivery of our parts of the solution.</td><td>' .
			$member_entry . '</td></tr>';
	
	$uid = $case_info->gatekeeper;
	$member_entry = (($user->uid == $case_info->coordinator) || ($user->uid == 1)) ?
			get_team_menu($team, 'gatekeeper', 'not assigned', $uid, $editable) :
			(($uid > 0) ? get_fullname($team, $uid) : 'not assigned');
	$form .= '<tr><td>Gatekeeper</td><td>Make sure that everyone gets a chance to contribute and that the team is not dominated by one or two people.  Help keep us on a productive timeline in Second Life meetings.</td><td>' .
			$member_entry . '</td></tr>';
			
	$uid = $case_info->integrator;
	$member_entry = (($user->uid == $case_info->coordinator) || ($user->uid == 1)) ?
			get_team_menu($team, 'integrator', 'not assigned', $uid, $editable) :
			(($uid > 0) ? get_fullname($team, $uid) : 'not assigned');
	$form .= '<tr><td>Integrator</td><td>Ensuring that task deliverables are integrated and consistent, regardless of how the tasks are performed.</td><td>' .
			$member_entry . '</td></tr>';
			
	$form .= '</table></p>';
	if ($editable) {
		$form .= '<p align="center"><input type="submit" name="save_request" value="Save" /></p>';
	} else {
		if (($user->uid == $case_info->coordinator) || ($user->uid == 1)){
			if ($case_info->phase > 43){
				$form .= '<p align="center"  style="font-weight:bold; color:red">The project roles can no longer be updated.</p>';
			}
			else {
				// ie phase < 13:
				$form .= '<p align="center"  style="font-weight:bold; color:red">The project roles can not yet be updated.</p>';
			}
		}

		else
			$form .= '<p align="center"  style="font-weight:bold; color:red">The project roles can only be updated by the process coordinator.</p>';
	}
	$form .= '</form>';
	
	return $form;
}

function get_team_menu($team, $label, $no_txt, $uid, $enabled = true) {
	$select = '<select name="' . $label . '"';
	if (! $enabled)
		$select .= ' disabled="disabled"';
	$select .= '>';
		
	$select .= menu_option(-1, ($uid == -1), $no_txt);
	foreach ($team as $key => $member) {
		$select .= menu_option($member->uid, ($member->uid == $uid), $member->fullname);
	}
	
	$select .= '</select>';
	return $select;
}


function individual_em_form() {
	global $user;
	
	$case_id = CASE_ID;
	$case_info = get_case_info($case_id);
	$form = '<h2>Case: ' . $case_info->name . '</h2>';
	$form .= '<p>[<a href="/wiki/Procedure:Complete_Individual_Experience_Matrix" target="_blank">Help: SOP</a>]</p>';
	
	if ($case_info->phase < 31) {
		return $form . '<p style="font-weight:bold; color:red">Not yet enabled. Please contact the process coordinator.</p>';
	}
	
	$editable = ($case_info->phase <= 31);
	if ($editable && isset($_REQUEST['nr_dimensions'])) {
		$nr_dims = $_REQUEST['nr_dimensions'];
		$dimensions = get_dimensions($case_id, -1);
		for ($i = 0; $i < $nr_dims; $i++) {
		
			// insert new versions for changed rows:
			$dim_i = $dimensions[$i];
			$new_know = trim($_REQUEST['knowledge_' . $i]);
			$new_source = trim($_REQUEST['source_' . $i]);
			$user_info = get_experience($user->uid, $dim_i->did);
			if (($user_info->knowledge != $new_know) || ($user_info->source != $new_source)) {
				db_query(
					'INSERT INTO vcp_experience ' .
						'(did, uid, knowledge, source) ' .
					'VALUES ' . 
						'(%d,%d,"%s","%s")', $dim_i->did, $user->uid, $new_know, $new_source);
			}
		}
	}
	
	// generate the form from the database content:
	$dimensions = get_dimensions($case_id, -1);
	$nr_dims = sizeof($dimensions);
	$form .= '<p><b>Please supply additional information about yourself that is <i>not</i> specific to this case on <a href="user/' . 
			$user->uid . '/edit/Personal%20information">your profile page</a>.</b></p>';
	$form .= '<p><form action="' . $_SERVER["REQUEST_URI"] . '" method="post">';
	$form .= '<input type="hidden" name="nr_dimensions" value="' . $nr_dims . '" />';

	$form .= '<p><table border="1" cellpadding="4" width="100%">';
	$form .= '<tr><th>#</th><th>Dimension / Rationale</th><th>Relevant Skills / Knowledge<br /><i>(leave blank if none relevant)</i></th><th>Basis of Knowledge<br /><i>(leave blank if no skills/knowledge)</i></th></tr>';
	
	$ta_style = $editable ? 'width:98%' : 'width:98%; background: #eeeeee';
	for ($i = 0; $i < $nr_dims; $i++) {
	
		// write row for existing dimensions:
		$form .= '<tr>';
		$form .= '<td><b>' . ($i+1) . '</b></td>';
		$dim_i = $dimensions[$i];
		$form .= '<td>' . textarea($dim_i->description . "\n\n" . $dim_i->rationale, 
			'dimension_'.$i, 8, 'width:98%; background: #eeeeee', false) . '</td>';
		$user_info = get_experience($user->uid, $dim_i->did);
		$form .= '<td>' . textarea($user_info->knowledge, 'knowledge_'.$i, 8, $ta_style, $editable) . '</td>';
		$form .= '<td>' . textarea($user_info->source, 'source_'.$i, 8, $ta_style, $editable) . '</td>';
		$form .= '</tr>';
	}
	
	$form .= '</table></p>';
	if ($editable) {
		$form .= '<p align="center">' . submit_button('Save Changes', null) . '</p>';
	} else {
		$form .= '<p align="center"  style="font-weight:bold; color:red">The individual experience matrix can no longer be updated.</p>';
	}
	$form .= '</form>';
//	$form .= '<p>Please supply additional information about yourself that is not specific to this case on <a href="user/' . 
//			$user->uid . '/edit/Personal%20information">your OpenVCE profile</a>.</p>';
	return $form;
}


function accountability_form($team) {
	global $user;
	
	$case_id = CASE_ID;
	$case_info = get_case_info($case_id);
	$form = '<h2>Case: ' . $case_info->name . '</h2>';
	$form .= '<p>[<a href="/wiki/Procedure:Complete_Project_Plan_Accountability_Matrix" target="_blank">Help: SOP</a>]</p>';
	
	//$form .= '<p><b>Note: Accountability Matrix best viewed in Firefox.</b></p>';

	if ($case_info->phase < 32) {
		return $form . '<p style="font-weight:bold; color:red">Not yet enabled. See the <a href="progress-overview">progress overview</a> page.</p>';
	}
	
	// SEP incorrect? allow changes to be made after the generation of templates:
	//$editable = (($case_info->phase <= 43) && 
	$editable = (($case_info->phase >= 42) && 
		(($user->uid == $case_info->taskman) || ($user->uid == 1)));
	if ($editable && isset($_REQUEST['save_request'])) {
		// write changes to the database (if necessary):
		$nr_dims = $_REQUEST['nr_dimensions'];
		$dimensions = get_dimensions($case_id, -1);
		for ($i = 0; $i < $nr_dims; $i++) {
		
			$dim_i = $dimensions[$i];
			$approach = get_approach_info($dim_i->did, $team);
			if (dim_changed($i, $approach, $team)) {
				// insert new row into appraoch table:
				$new_vid = $approach['info']->vid + 1;
				db_query(
					'INSERT INTO vcp_approach VALUES ' . 
						'(%d,%d,%d,"%s","%s",%d)', 
						$dim_i->did, 
						$new_vid, 
						$_REQUEST['lead_'.$i], 
						trim($_REQUEST['approach_'.$i]), 
						trim($_REQUEST['deadline_'.$i]),
						$approach['info']->solution_nid);
				// insert new subteam information:
				$checked = $_REQUEST['dim_team_'.$i];
				if ($checked == null)
					$checked = array();
				foreach ($checked as $key => $uid) {
					db_query('INSERT INTO vcp_subteam VALUES ' . 
						'(%d,%d,%d)', $dim_i->did, $uid, $new_vid);
				}
			}
		}
	}
	
	if (isset($_REQUEST['generate_slides_request'])) {
		// write the slides:
		$form .= generate_experience_slides($team, $case_info);
	}
	
	if (isset($_REQUEST['generate_solutions_request'])) {
		$nr_dims = $_REQUEST['nr_dimensions'];
		$dimensions = get_dimensions($case_id, -1);
		$tuserid = $user->uid;
  		module_load_include('inc', 'node', 'node.pages');
		for ($i = 0; $i < $nr_dims; $i++) {
			$dim_i = $dimensions[$i];
			$approach = get_approach_info($dim_i->did, $team);

			// set 'current user' to the lead in order to assign ownership of node:
			$user = user_load(array(uid => ($approach[info]->lead_uid)));

			// generate solution template for dimension:
			//$form .= 'generating template ' . $i . ': ';
			// Load node.form.inc from the node module.
			// Load content_types.inc from the node module.
  			//module_load_include('inc', 'node', 'content_types');  

			$new_node = array('type' => 'vcp_dimension_solution_template');

			$new_node_values = array();
			$new_node_values['values']['title'] = 'Solution for Problem Dimension #'.($i+1);
			$new_node_values['values']['field_solution_dimension'] = array(array('value' => $dim_i->description));

			// SEP altered: does an 'empty' $approach[info]->description cause a problem here?:
			$new_node_values['values']['field_solution_approach'] = array(array('value' => '(enter details of the solution here)')); //$approach[info]->description));
			$new_node_values['values']['field_solution_actions'] = array(array('value' => '(enter details of any actions required to implement this solution)'));
			$new_node_values['values']['field_additional_resources'] = array(array('value' => '(enter details of any additional required resources here)'));
			//$new_node_values['values']['body'] = 'body text';
			//$new_node_values['values']['uid'] = 9;
			//$new_node_values['values']['name'] = 'gwickler'; // get_name($team,$approach[info]->lead_uid);
			$new_node_values['values']['status'] = 1;
			//$new_node_values['values']['og_groups'] = array ( TEAM_ID => TEAM_ID ); 
			//$new_node_values['values']['og_groups_both'] = array ( TEAM_ID => 'Team A' ); 
			//$new_node_values['values']['og_public'] = 1;
			$new_node_values['values']['op'] = t('Save');


			$err = drupal_execute('vcp_dimension_solution_template_node_form', $new_node_values, (object)$new_node);
			//$newnid = drupal_execute('page_node_form', $new_node_values, $new_node);
			//print_r($new_node);
			$newnid = $new_node_values['nid'];
			//$form .= '<a href="node/'.$newnid.'">new page</a><br />'; 
			// write nid to database:
			db_query('UPDATE vcp_approach SET solution_nid=%d WHERE did=%d AND vid=%d', $newnid, $dim_i->did, $approach['info']->vid);
			
		}

		// reset to original 'current user':
		$user = user_load(array(uid => $tuserid));
	}
	
	// generate the form from the database content:
	$dimensions = get_dimensions($case_id, -1);
	$nr_dims = sizeof($dimensions);
	$form .= '<p><form action="' . $_SERVER["REQUEST_URI"] . '" method="post">';
	$form .= '<input type="hidden" name="nr_dimensions" value="' . $nr_dims . '" />';
	$form .= '<p><table border="1" cellpadding="4" width="100%">';
	$form .= '<tr><th>#</th><th width="30%">Dimension / Rationale</th><th>Subteam</th><th>Solution Approach</th><th width="5%">Deadline</th></tr>';
	
	$ta_rows = sizeof($team) + 3;
	$ta_style = $editable ? 'width:95%' : 'width:95%; background: #eeeeee';
	for ($i = 0; $i < $nr_dims; $i++) {
	
		// write row for existing dimensions:
		$form .= '<tr>';
		$form .= '<td><b>' . ($i+1) . '</b></td>';
		$dim_i = $dimensions[$i];
		
		$form .= '<td>' . textarea($dim_i->description . "\n\n" . $dim_i->rationale, 
			'dimension_'.$i, $ta_rows, 'width:95%; background: #eeeeee', false) . '</td>';
		
		$approach = get_approach_info($dim_i->did, $team);

		// SEP added: only allow lead to be edited if a solution template has *not* been generated:
		$lead_editable = $editable && ($approach['info']->solution_nid == -1);
		$form .= '<td>Lead: ' . get_team_menu($team, 'lead_'.$i, 'unassigned', $approach['info']->lead_uid, $lead_editable) . '<br />';

		$form .= 'Team:';
		foreach ($team as $key => $member) {
			$form .= '<br />&nbsp;' . checkbox(
				'dim_team_'.$i.'[]', $member->uid, ($approach['subteam'][$member->uid] != null), $member->fullname, $editable);
		}
		$form .= '</td>';
		
		$form .= '<td>' . textarea($approach['info']->description, 
			'approach_'.$i, $ta_rows, $ta_style, $editable);
		if ($approach['info']->solution_nid != -1) {
			$form .= '<p align="center"><a href="/node/' .
					$approach['info']->solution_nid . '">Solution</a></p>';
		}
		$form .= '</td>';
		
		$form .= '<td>' . textfield($approach['info']->deadline, 'deadline_'.$i, 15, $editable) . '</td>';
		$form .= '</tr>';
	}
	
	$form .= '</table></p>';
	if (($user->uid == $case_info->coordinator) || ($user->uid == 1)) {
		if (($case_info->phase >= 32) && ($case_info->phase <=41))
			$form .= '<p align="center">' . submit_button('Generate Presentation', 'generate_slides_request') . '</p>';
		else {
			// SEP commented out because it was causing confusion to PC who is also CP (aka taskman):
			//$form .= '<p align="center"  style="font-weight:bold; color:red">No action possible at this time.</p>';
		}
	}
	if (($user->uid == $case_info->taskman) || ($user->uid == 1)) {
		$form .= '<p align="center">';

		// SEP altered to allow changes to the matrix the second meeting:
		//if (($case_info->phase >= 41) && ($case_info->phase <=43))
		if ($case_info->phase >= 41)
			$form .= submit_button('Save Changes', 'save_request') . ' ';

		// SEP altered to allow the templates to be generated whenever they're ready:
		//if (($case_info->phase == 43) && ($approach['info']->solution_nid == -1))
		if (($case_info->phase >= 43) && ($approach['info']->solution_nid == -1))

			$form .= submit_button('Generate Solution Templates', 'generate_solutions_request');

		// SEP commented out to reflect above changes:
		//if ($case_info->phase >= 51)
		//	$form .= '<p align="center"  style="font-weight:bold; color:red">No action possible at this time.</p>';
		$form .= '</p>';
	}

	// SEP altered - logic wrong?
	if (($user->uid != $case_info->coordinator) && 
			//($user->uid != $case_info->taskman) && ($user->uid == 1)) {
			($user->uid != $case_info->taskman) && ($user->uid != 1)) {

		$form .= '<p align="center"  style="font-weight:bold; color:red">The accountability matrix can only be updated by the case planner.</p>';
	}
	$form .= '</form>';
	return $form;
}

function dim_changed($rowi, $approach, $team) {
	if ($approach['info']->lead_uid != $_REQUEST['lead_'.$rowi])
		return true;
	$checked = $_REQUEST['dim_team_'.$rowi];
	if ($checked == null)
		$checked = array();
	$team_db = $approach['subteam'];
	if (sizeof($team_db) != sizeof($checked))
		return true;
	foreach ($checked as $key => $uid) {
		if ($team_db[$uid] == null) 
			return true;
	}
	if ($approach['info']->description != trim($_REQUEST['approach_'.$rowi]))
		return true;
	if ($approach['info']->deadline != trim($_REQUEST['deadline_'.$rowi]))
		return true;
	return false;
}

function get_fullname($team, $uid) {
	foreach ($team as $key => $member) {
		if ($member->uid == $uid)
			return $member->fullname;
	}
	return 'unknown member';
}

function get_name($team, $uid) {
	foreach ($team as $key => $member) {
		if ($member->uid == $uid)
			return $member->name;
	}
	return 'unknown';
}

/**
 * Get the members of the given team.
 * @param team_id the nid of the drupal group
 * @return an array of associative arrays each with keys 'uid', 'fullname' and 'name'
 */
function get_team_members($team_id) {
	$result = array();
	$db_result = db_query(
			'SELECT profile_values.uid, value AS fullname, name FROM profile_values, og_uid, users '.
				'WHERE og_uid.nid = %d AND og_uid.uid = profile_values.uid AND og_uid.uid = users.uid AND fid = %d AND profile_values.uid <> 1 '.
				'ORDER BY fullname ASC', $team_id, FULLNAME_FIELD_ID);
	while($nextmember = db_fetch_object($db_result)){
			$result[] = $nextmember;       										   
		}
	return $result;
}

/**
 * Get the strings representing the user experience for a given user and dimension.
 * @param user the uid of the user in question
 * @param dim the dimension id for the relevant dimension
 * @return an associative array with keys 'knowledge' and 'source'
 */
function get_experience($user, $dim) {
	$max_qr = db_fetch_object(
		db_query('SELECT MAX(vid) AS mvid FROM vcp_experience WHERE did=%d AND uid=%d', $dim, $user));
	if ($max_qr->mvid != null) {
		return db_fetch_object(
			db_query('SELECT knowledge, source FROM vcp_experience WHERE did=%d AND uid=%d AND vid=%d', $dim, $user, $max_qr->mvid));
	}
	$result = array();
	$result['knowledge'] = '';
	$result['source'] = '';
	return $result;
}
	
/**
 * Get the problem dimensions from the database.
 * @param case_id the case
 * @param user the uid of the author, or -1 for integrated
 * @return an array of dimensions, where each dimension is itself an associative array
 */
function get_dimensions($case_id, $user) {
	$result = array();

	$query = ($user >= 0) ?
		'SELECT DISTINCT did, max(vid) AS mvid FROM vcp_dimension WHERE cid = ' . $case_id . ' AND uid=' . $user . ' GROUP BY did ORDER BY did ASC':
		'SELECT DISTINCT did, max(vid) AS mvid FROM vcp_dimension WHERE cid = ' . $case_id . ' AND integrated=1 GROUP BY did ORDER BY did ASC';
	$db_result = db_query($query);
	if($db_result != FALSE) {
		while($nextdim = db_fetch_object($db_result)) {
			$db_result2 = db_query(
				'SELECT did, vid, description, rationale, priority FROM vcp_dimension WHERE did=%d AND vid=%d', $nextdim->did, $nextdim->mvid); 
			$result[] = db_fetch_object($db_result2); 											   
		}
	}
	return $result;
}

/**
 * Get the basic case information for the given case. NOTE: the avatar name of the
 * process coordinator is hard-wired into this script (see the define at the top)
 * @param case_id the case
 * @return an associative array with keys: 'name' and 'coordinator'
 */
function get_case_info($case_id) {
	return db_fetch_object(
		db_query('SELECT * FROM vcp_case WHERE cid=%d', $case_id)); 
}

/**
 * Get the information for the solution approach to the given dimension. It returns
 * an associative array containing fields from the database plus the set of subteam
 * member associated with the key 'subteam'.
 */
function get_approach_info($did, $team) {
	$approach = array();
	$maxv_qr = db_fetch_object(
		db_query('SELECT MAX(vid) as maxv FROM vcp_approach WHERE did=%d', $did));
	if ($maxv_qr->maxv) {
		$approach['info'] = db_fetch_object(
			db_query('SELECT * FROM vcp_approach WHERE did=%d and vid=%d', $did, $maxv_qr->maxv));
	} else {
		// dimension was not in DB:
		db_query('INSERT INTO vcp_approach (did, vid) ' .
				'VALUES (' . $did . ', 1)');
		$approach['info'] = db_fetch_object(
			db_query('SELECT * FROM vcp_approach WHERE did=%d', $did));
		$vid = $approach['info']->vid;
		foreach ($team as $key => $member) {
			if (get_experience($member->uid, $did)->knowledge != '') {
				db_query('INSERT INTO vcp_subteam VALUES (%d,%d,%d)', 
						$did, $member->uid, $vid);
			}
		}
	}
	
	$subteam = db_query(
		'SELECT uid FROM vcp_subteam WHERE did=%d AND vid=%d', $did, $approach['info']->vid);
	$members = array();
	while ($member = db_fetch_object($subteam)) {
		$members[$member->uid] = $member->uid;
	}
	$approach['subteam'] = $members;
	
	return $approach;
}

function get_subteam_checkboxes($team, $subteam, $label, $editable) {
	$boxes = '';
	foreach ($team as $key => $member) {
		$boxes .= '<br />&nbsp;' . checkbox($label.'[]', $member->uid, ($subteam[$member->uid] != null), $member->fullname, $editable);
		/*$boxes .= '<br />&nbsp;<input type="checkbox" name="'.$label.'[]" value="'.$member->uid.'" ';
		if ($subteam[$member->uid] != null)
			$boxes .= 'checked="checked" ';
		$boxes .= '/>&nbsp;'.$member->fullname;*/
	}
	return $boxes;
}

/**
 * unlinkRecursive - deletes the contents of a directory recursively.
 */
/*
function unlinkRecursive($dir, $deleteRootToo)
{
    if(!$dh = @opendir($dir))
    {
        return;
    }
    while (false !== ($obj = readdir($dh)))
    {
        if($obj == '.' || $obj == '..')
        {
            continue;
        }

        if (!@unlink($dir . '/' . $obj))
        {
            unlinkRecursive($dir.'/'.$obj, true);
        }
    }

    closedir($dh);
   
    if ($deleteRootToo)
    {
        @rmdir($dir);
    }
   
    return;
} 
*/


function generate_experience_slides($team,$case_info){

	$dimensions = get_dimensions($case_info->cid, -1);
	$nr_dims = sizeof($dimensions);
	$form = '';

        // probably needs another condition:
	if ($nr_dims > 0) {
	
		global $base_url;

  		$avatarname = preg_replace('/\s+/','_',trim(PC_AVATAR_NAME));

    		$adir = realpath('.').file_directory_temp().'/'.$avatarname; // avatar dir - may already exist
    		if(!is_dir($adir)) mkdir($adir);

		$pname = SL_PRESENTATION_DIR_ROOT.'-Team-Experience';
    		$pdir = $adir.'/'.$pname.'/'; // presentation dir

		unlinkRecursive($pdir,true);
		mkdir($pdir);


		for ($i = 0; $i < $nr_dims; $i++) {

			// generate a new 'slide' for each dimension:
			$fp = fopen($pdir.'slide'.$i.'.html', 'w');
			fwrite($fp, '<html><head><meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>');
			fwrite($fp, '<style type="text/css">'
					.'h1,h2,p,ul { font-family: "Arial Black"; margin: 40px }'
					.'h1 {font-size: 36pt; text-align: center}'
					.'h2 {font-size: 24pt}'
					.'ul {font-size: 18pt; margin: 20px}'
					.'p {font-size: 18pt}</style></head><body>');
			//fwrite($fp, '<h1>'.$case_info->name.': Problem Dimension #'.($i+1).'</h1>');
			fwrite($fp, '<h1>Problem Dimension #'.($i+1).'</h1>');
			
			$dim_i = $dimensions[$i];
			//fwrite($fp, '<h2>Dimension (ranking: '.$dim_i->priority.')</h2><p>'.$dim_i->description.'</p>');
			//fwrite($fp, '<h2>'.$dim_i->description.'</h2>');
			fwrite($fp, '<ul><li>'.truncate($dim_i->description, 50, '...').'</li><li>rationale: '.truncate($dim_i->rationale,50,'...').'</li><li>ranking: '.$dim_i->priority.'</li></ul>');
			//fwrite($fp, '<h2>Rationale</h2><p>'.$dim_i->rationale.'</p>');
			//fwrite($fp, '<h2>Ranking: '.$dim_i->priority.'</h2>'); 

			fwrite($fp, '<h2>Knowledge/Skills</h2><ul>');

			$knowtext = '';

			foreach ($team as $key => $member) {
				// want to get knowledge/source for the current dimension
			        $exper = get_experience($member->uid, $dim_i->did);	
				if($exper->knowledge != ''){
				           $knowtext .= '<li>'.$member->fullname.': '.$exper->knowledge;
					   if($exper->source != ''){
					       $knowtext .= ' <ul><li>based on: '.$exper->source.'</li></ul>';
					      }
                                           $knowtext .= '</li>';
				}
			}

			if($knowtext == '') $knowtext .= 'none';

			fwrite($fp, $knowtext.'</ul></body>');
			fclose($fp);
		}
		$form .= '<p>Presentation '.$pname.' has been generated:</p><ul>';

		
		$urlroot = $base_url.file_directory_temp().'/'.$avatarname.'/'.$pname.'/slide';

		for ($i = 0; $i < $nr_dims; $i++) {
			$fullurl = $urlroot.$i.'.html';
			$form .= '<li><a href="'.$fullurl.'">'.$fullurl.'</a></li>';
		}
		$form .= '</ul>';
	}
	
	return $form;
}

function textarea($content, $name, $rows, $style, $editable = true) {
	$result = '<textarea';
	$result .= ' name="' . $name . '"';
	$result .= ' rows="' . $rows . '"';
	$result .= ' style="' . $style . '"';
	if (! $editable)
		$result .= ' readonly="readonly"';
	$result .= '>' . $content . '</textarea>';
	return $result;
}

function textfield($content, $name, $size, $editable = true) {
	$result = '<input type="text"';
	$result .= ' name="' . $name . '"';
	$result .= ' size="' . $size . '"';
	if (! $editable)
		$result .= ' disabled="disabled"';
	$result .= ' value="' . $content . '" />';
	return $result;
}

function radio_button($name, $value, $checked, $text, $enabled = true) {
	$result = '<input type="radio"';
	$result .= ' name="' . $name . '"';
	$result .= ' value="' . $value . '"';
	if ($checked)
		$result .= ' checked="checked"';
	if (! $enabled)
		$result .= ' disabled="disabled"';
	$result .= ' />&nbsp;' . $text;
	return $result;
}

function checkbox($name, $value, $checked, $text, $enabled = true) {
	$result = '<input type="checkbox"';
	$result .= ' name="' . $name . '"';
	$result .= ' value="' . $value . '"';
	if ($checked)
		$result .= ' checked="checked"';
	if (! $enabled)
		$result .= ' disabled="disabled"';
	$result .= ' />&nbsp;' . $text;
	return $result;
}

function menu_option($value, $selected, $text, $enabled = true) {
	$result = '<option';
	$result .= ' value="' . $value . '"';
	if ($selected)
		$result .= ' selected="selected"';
	if (! $enabled)
		$result .= ' disabled="disabled"';
	$result .= '>' . $text . '</option>';
	return $result;
}

function submit_button($text, $name) {
	$result = '<input type="submit"';
	if ($name != null)
		$result .= ' name="' . $name . '"';
	$result .= ' value="' . $text . '"';
	$result .= ' />';
	return $result;
}

function truncate($string, $max = 20, $rep = '')
{
    if (strlen($string) <= ($max + strlen($rep)))
    {
        return $string;
    }
    $leave = $max - strlen ($rep);
    return substr_replace($string, $rep, $leave);
} 